//#include <CapacitiveSensor.h>
//
//int   touchRead(15) = touchRead(15);
//int   touchRead(16) = touchRead(16);
//int   touchRead(17) = touchRead(17);

//touch pins
int swipePin1 = 15;
int swipePin2 = 16;
int swipePin3 = 17;
int tapPin = 19;

//EL pins

int elOne = 23; // elSeg 1 & 9
int elThree = 14; // elSeg 3
int elFour = 18; // elSeg 4
int elFive = 20; // elSeg 5
int elSix = 21; // elSeg 6
int elSeven = 22; // elSeg 7



int out1 = 12;
int VOut = 11;

bool capValArray[] = {false, false, false};
bool prevCapValArray[] = {false, false, false};
bool prevPrevCapValArray[] = {false, false, false};  //I'm so sorry
bool tapOn = false;
float threshold[] = {0, 0, 0, 0};

int timeoutMillis = 300;
bool leftTouch = false;
bool rightTouch = false;
long leftTouchStartTime, rightTouchStartTime;
long touchEndTime, tapEndTime;

bool PLAYING = false;

void setup() {
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(out1, OUTPUT);
  pinMode(VOut, OUTPUT);

  pinMode(4, OUTPUT);

  //pinMode(13, OUTPUT);
  
  pinMode(elOne, OUTPUT);
  pinMode(elThree, OUTPUT);
  pinMode(elFour, OUTPUT);
  pinMode(elFive, OUTPUT);
  pinMode(elSix, OUTPUT);
  pinMode(elSeven, OUTPUT);

  

  digitalWrite(VOut, HIGH);
  digitalWrite(out1, HIGH);
  digitalWrite(4, LOW);

  Serial.begin(9600);

  initialize();
}

void loop() {
  
  updateSensor();
  checkGesture();
  checkTap();
  
//  printCapValues();

  //output
  turnELOff();
  if (PLAYING) {
    //illuminate PLAY segments
    digitalWrite(elSeven, HIGH);
    digitalWrite(elSix, HIGH);
    digitalWrite(elFour, HIGH);
    digitalWrite(elThree, HIGH);
  }
  else {
    //illuminate PAUSE segments
    digitalWrite(elFour, HIGH);
    digitalWrite(elThree, HIGH);
    digitalWrite(elOne, HIGH);

    
  }
  delay(5); //for multiplexing
}

int updateSensor() {
  capValArray[0] = touchRead(swipePin1) > threshold[0];
  capValArray[1] = touchRead(swipePin2) > threshold[1];
  capValArray[2] = touchRead(swipePin3) > threshold[2];
  //capValArray[2] = touchRead(tapPin) > threshold[3];
  //Serial.println(capValue);
  delay(10);
  //  Serial.println(capValue);
}

void leftSwipe() {
  turnELOff();
  delay(10);
  //illuminate skip back icon
  digitalWrite(elFive, HIGH);
  digitalWrite(elThree, HIGH);
  digitalWrite(elOne, HIGH);
  
  //send skip back message to computer (see below)
  Serial.println("0");
  delay(800);
  //delay for amount of time to show icon
  //come back to this place
}

void rightSwipe() {
  turnELOff();
  delay(10);
  //illuminate skip forward icon
  digitalWrite(elFour, HIGH);
  digitalWrite(elSeven, HIGH);
  
  //send skip forward message to computer (see below)
  Serial.println("1");
  delay(800);
  //delay for amount of time to show icon
  //come back to this place
  
}

void tapAction() {
  Serial.println("Tap");
  PLAYING = !PLAYING;
  if (PLAYING) {
    //send play message to computer
    Serial.println("3");
    //turn all off
    //illuminate play segments
  }
  else {
    Serial.println("4");
    //send pause message to computer
    //turn all off
    //illuminate pause segments
  }
}

void checkTap() {
  turnELOff();
  bool tempTap = touchRead(tapPin) > threshold[3];
  if (!tempTap && tapOn && millis() - tapEndTime > timeoutMillis) {
    //do something
    tapAction();
    tapEndTime = millis();
  }
  tapOn = tempTap;
  delay(2); //for multiplexing
}

void turnELOff() {
  digitalWrite(elOne, LOW);
  digitalWrite(elThree, LOW);
  digitalWrite(elFour, LOW);
  digitalWrite(elFive, LOW);
  digitalWrite(elSix, LOW);
  digitalWrite(elSeven, LOW);
  
  
}

void checkGesture() {

  if (capValArray[0] && !prevCapValArray[0] && !leftTouch && !rightTouch) { //left contact touched
    leftTouch = true;
    leftTouchStartTime = millis();
  }
  else if (capValArray[2] && !prevCapValArray[2] && !leftTouch && !rightTouch) {
    rightTouch = true;
    rightTouchStartTime = millis();
  }

  //gesture timeout
  if (leftTouch) {
    int elapsedTime = millis() - leftTouchStartTime;
    if (elapsedTime > timeoutMillis) {
      leftTouch = false;
    }
  }
  if (rightTouch) {
    int elapsedTime = millis() - rightTouchStartTime;
    if (elapsedTime > timeoutMillis) {
      rightTouch = false;
    }
  }

  //middle contact touched
  if (capValArray[1] && !prevCapValArray[1]) {
    if (leftTouch) {
      leftTouchStartTime = millis();
    }
    else if (rightTouch) {
      rightTouchStartTime = millis();
    }
  }

  //gesture finished (crossed all three contacts and gesture is active)
  if (capValArray[2] && !prevCapValArray[2] && leftTouch) {
    if (millis() - touchEndTime > timeoutMillis) {
      rightSwipe();
      touchEndTime = millis();
    }
  }
  else if (capValArray[0] && !prevCapValArray[0] && rightTouch) {
    if (millis() - touchEndTime > timeoutMillis) {
      leftSwipe();
      touchEndTime = millis();
    }
  }
  /*
    //if any contact is released and gesture is not happening
    else if ((!capValArray[0] && !prevCapValArray[0] && prevPrevCapValArray[0]) ||
           (!capValArray[1] && !prevCapValArray[1] && prevPrevCapValArray[1]) ||
           (!capValArray[2] && !prevCapValArray[2] && prevPrevCapValArray[2])
           && !rightTouch && !leftTouch
           && millis() - touchEndTime > timeoutMillis * 3) {
    tapGesture();
    touchEndTime = millis();
    }
  */

  //shift current values to previous
  for (int i = 0; i < 3; i++) {
    prevPrevCapValArray[i] = prevCapValArray[i]; //ew
    prevCapValArray[i] = capValArray[i];
  }
}

void printCapValues() {
  Serial.print(capValArray[0]);
  Serial.print(" | ");
  Serial.print(capValArray[1]);
  Serial.print(" | ");
  Serial.println(capValArray[2]);
}

void printRawCapValues() {
  Serial.print(touchRead(swipePin1));
  Serial.print(" | ");
  Serial.print(touchRead(swipePin2));
  Serial.print(" | ");
  Serial.println(touchRead(swipePin3));
}

void initialize() {
  //waits 3 seconds to take readings
  delay(100);
  for (int i = 0; i < 4; i++) {
    int baselineAvg[] = {0, 0, 0, 0};

    //throw out first 200 readings
    for (int j = 0; j < 200; j++) {
      int temp[] = {touchRead(swipePin1), touchRead(swipePin2), touchRead(swipePin3), touchRead(tapPin)};
      //    Serial.println(temp);
      delay(5);
    }

    Serial.println("----------");

    int numReadings = 100;
    //average 100 readings from cap sensor
    for (int j = 0; j < numReadings; j++) {
      int reading[] = {touchRead(swipePin1), touchRead(swipePin2), touchRead(swipePin3), touchRead(tapPin)};
      baselineAvg[i] += reading[i];
      Serial.println(reading[i]);
      delay(1);
    }
    baselineAvg[i] = baselineAvg[i] / numReadings;
    Serial.println(baselineAvg[i]);

    //threshold is 1.5 times baseline value
    threshold[i] = baselineAvg[i] * 1.2;
    Serial.print("Threshold set to ");
    Serial.println(threshold[i]);
    delay(100);
  }
}



